using System;

namespace Game
{
	public enum Mouse_Key
	{
		Left = 1,
		Right = 2,
		Middle = 4
	}

	/// <summary>
	/// Summary description for Mouse_State.
	/// </summary>
	public class Mouse_State
	{
		public int x = 0;
		public int y = 0;
        
		private int newMask = 0;
		private int oldMask = 0;

		public Mouse_State()
		{
		}

		public bool Is_Down( Mouse_Key key )
		{
			return ( newMask & (int)key ) != 0;
		}

		public bool Is_Up( Mouse_Key key )
		{
			return ( newMask & (int)key ) == 0;
		}

		public bool Is_Pressed( Mouse_Key key )
		{
			return Is_Down(key) && ( ( oldMask & (int)key ) == 0 );
		}

		public bool Is_Released( Mouse_Key key )
		{
			return Is_Up(key) && ( ( oldMask & (int)key ) != 0 );
		}

		public void Update()
		{
			oldMask = newMask;
		}

		public void Set_Key( Mouse_Key key, bool state )
		{
			if ( state )
				newMask |= (int)key;
			else
				newMask &= ~(int)key;
		}
	}
}
